--- old/usr/src/cmd/truss/expound.c	Wed Oct  9 15:51:46 2013
+++ new/usr/src/cmd/truss/expound.c	Wed Oct  9 15:51:46 2013
@@ -3485,12 +3485,12 @@
 	 * A buffer large enough for PATH_MAX size AF_UNIX address, which is
 	 * also large enough to store a sockaddr_in or a sockaddr_in6.
 	 */
-	long buf[(sizeof (short) + PATH_MAX + sizeof (long) - 1)
-	    / sizeof (long)];
-	struct sockaddr *sa = (struct sockaddr *)buf;
-	struct sockaddr_in *sin = (struct sockaddr_in *)buf;
-	struct sockaddr_un *soun = (struct sockaddr_un *)buf;
-	struct sockaddr_in6 *sin6 = (struct sockaddr_in6 *)buf;
+	struct sockaddr_storage buf;
+
+	struct sockaddr *sa = (struct sockaddr *)&buf;
+	struct sockaddr_in *sin = (struct sockaddr_in *)&buf;
+	struct sockaddr_un *soun = (struct sockaddr_un *)&buf;
+	struct sockaddr_in6 *sin6 = (struct sockaddr_in6 *)&buf;
 	char addrbuf[INET6_ADDRSTRLEN];
 
 	if (lenoff != 0) {
@@ -3502,7 +3502,7 @@
 
 	if (len >= sizeof (buf))	/* protect against ridiculous length */
 		len = sizeof (buf) - 1;
-	if (Pread(Proc, buf, len, addroff) != len)
+	if (Pread(Proc, (void*)&buf, len, addroff) != len)
 		return;
 
 	switch (sa->sa_family) {
